﻿package clases
{
	import flash.display.*;
	import flash.geom.*;
	public class LineaVoladora extends Sprite
	{
		var count:int = 0;
		var p1:Point = new Point(100,100);
		var p2:Point = new Point(200,100);
		var darken:ColorTransform = new ColorTransform(1,1,0,0.9);
		public var posX:int = 0;
		var velPosX:Number = Math.random() * 3;
		var topePosX:int = 450;
		public var posY:int = 0;
		var velPosY:Number = Math.random() * 3;
		var topePosY:int = 380;
		var countColor:int = 0;
		var maxColor:int = 255;
		var sumaColor:int = 1;
		var mydisplay:Sprite;
		var startHex:uint = 0xff0000;
		var endHex:uint = 0xffff00;
		var diam1:int = 20;
		var diam2:int = 20;
		var w:int = 100;
		var thick:int = 1;
		var sumaCirculo:int = 1;
		public function LineaVoladora(display:Sprite,diam1:int,diam2:int,color1:uint=0xff0000,color2:uint=0x00ff00,w:int=100,thick:int = 1)
		{
			sumaCirculo = 1;
			this.w = w;
			this.diam1 = diam1;
			this.diam2 = diam2;
			this.thick = thick;
			startHex = color1;
			endHex = color2;
			mydisplay = display;
			mydisplay.addChild(this);
		}
		public function update()
		{

			p1.x = diam1 * Math.sin(Math.PI * count / 180 );
			p1.y = diam1 * Math.cos(Math.PI * count / 180 );
			p2.x = (w) + diam2 * Math.cos(Math.PI * count / 180 );
			p2.y =  diam2 * Math.sin(Math.PI * count / 180 );
			if(posX >= topePosX)
			{
				//velPosX = - Math.random() * 4;
				velPosX = -1;
			}else if(posX <= 0)
			{
				//velPosX = + Math.random() * 4;
				velPosX = 1;
			}
			if(posY >= topePosY)
			{
				//velPosY = - Math.random() * 4;
				velPosY = -1;
			}else if(posY <= 0)
			{
//				velPosY = Math.random() * 4;
				velPosY = 1;
			}
			posX += velPosX;
			posY += velPosY;
			//trace("PosX:" + posX);
			
			count += sumaCirculo;
			if(count>=360)
			{
				count = 0;
			}
			if(countColor >= 253)
			{
				sumaColor = -1;
			}else if(countColor <= 2){
				sumaColor = 1;
			}
			countColor += sumaColor;
			
		}
		public function redraw()
		{
			
			var l:Sprite = new Sprite();
			l.graphics.lineStyle(thick,fadeHex(countColor));
			l.graphics.moveTo(p1.x, p1.y);
			l.graphics.lineTo(p2.x, p2.y);
			l.graphics.endFill();
			l.x = posX;
			l.y = posY;
			mydisplay.addChild(l);
			if(mydisplay.numChildren > 100)
			{
				mydisplay.removeChildAt(0);
			}

		}
		function fadeHex(ratio) {
			var r = startHex >> 16;
			var g = startHex >> 8 & 0xFF;
			var b = startHex & 0xFF;
			r += ((endHex >> 16 & 0xFF)-r)*ratio;
			g += ((endHex >> 8 & 0xFF)-g)*ratio;
			b += ((endHex & 0xFF)-b)*ratio; 
			return (r << 16 | g << 8 | b);
		}
	}
}